redrawstatus = 1
katzolwia = 0
pozycjax = 300
pozycjay = 300
rysowanie = 1

function forward(dlugosc)
    local a, b, x, y
    a = (math.sin(katzolwia * math.pi / 180) * dlugosc)
    b = (math.cos(katzolwia * math.pi / 180) * dlugosc)
    x = pozycjax + a
    y = pozycjay - b
    if rysowanie == 1 then
        line (pozycjax, pozycjay, x, y)
    end
    pozycjax = x
    pozycjay = y
    if redrawstatus == 1 then
		redraw()
	end
end

function backward(dlugosc)
    local a, b, x, y
    a = (math.sin(katzolwia * math.pi / 180) * dlugosc)
    b = (math.cos(katzolwia * math.pi / 180) * dlugosc)
    x = pozycjax - a
    y = pozycjay + b
    if rysowanie == 1 then
		line (pozycjax, pozycjay, x, y)
    end
    pozycjax = x
    pozycjay = y
    if redrawstatus == 1 then
		redraw()
	end
end 

function turnright(zmiana)
    katzolwia = katzolwia + zmiana
    if katzolwia > 360 then
        katzolwia = katzolwia - 360
    end
    if katzolwia < 0 then
        katzolwia = katzolwia + 360
    end
end

function turnleft (zmiana)
    katzolwia = katzolwia - zmiana
    if katzolwia > 360 then
        katzolwia = katzolwia - 360
    end
    if katzolwia < 0 then
        katzolwia = katzolwia + 360
    end
end

function penup()
    rysowanie = 0
end

function pendown()
    rysowanie = 1
end

function goxy(zmianax, zmianay)
    pozycjax = zmianax
    pozycjay = zmianay
end

function gox(zmianax)
    pozycjax = pozycjax + zmianax
end

function goy(zmianay)
    pozycjay = pozycjay + zmianay
end

function setredraw(zmiana)
	if zmiana == 0 then
		redrawstatus = 0
	elseif zmiana == 1 then
		redrawstatus =1
	end
end

function resetangle()
    katzolwia = 0
end

function setbgcolour(kolor)
	if kolor == "white" then backcolour(255, 255, 255)
	elseif kolor == "black" then backcolour(0, 0, 0)
	elseif kolor == "red" then backcolour(255, 0, 0)
	elseif kolor == "green" then backcolour(0, 255, 0)
	elseif kolor == "blue" then backcolour(0, 0, 255)
	elseif kolor == "yellow" then backcolour(255, 255, 0)
	elseif kolor == "grey" then backcolour(128, 128, 128)
	elseif kolor == "purple" then backcolour(128, 0, 128)
	elseif kolor == "aqua" then backcolour(0, 0, 255)
	elseif kolor == "teal" then backcolour(0, 128, 128)
	elseif kolor == "olive" then backcolour(128, 128, 0)
	elseif kolor == "maroon" then backcolour(128, 0, 0)
	elseif kolor == "navy" then backcolour(0, 0, 128)
	elseif kolor == "magenta" then backcolour(255, 0, 255)
	elseif kolor == "lightgrey" then backcolour(211, 211, 211)
	elseif kolor == "darkgrey" then backcolour(64, 64, 64)
	elseif kolor == "lightblue" then backcolour(173, 216, 230)
	end
	clearscreen()
end

function setcolour(kolor)
	if kolor == "white" then colour(255, 255, 255)
	elseif kolor == "black" then colour(0, 0, 0)
	elseif kolor == "red" then colour(255, 0, 0)
	elseif kolor == "green" then colour(0, 255, 0)
	elseif kolor == "blue" then colour(0, 0, 255)
	elseif kolor == "yellow" then colour(255, 255, 0)
	elseif kolor == "grey" then colour(128, 128, 128)
	elseif kolor == "purple" then colour(128, 0, 128)
	elseif kolor == "aqua" then colour(0, 255, 255)
	elseif kolor == "teal" then colour(0, 128, 128)
	elseif kolor == "olive" then colour(128, 128, 0)
	elseif kolor == "maroon" then colour(128, 0, 0)
	elseif kolor == "navy" then colour(0, 0, 128)
	elseif kolor == "magenta" then colour(255, 0, 255)
	elseif kolor == "lightgrey" then colour(211, 211, 211)
	elseif kolor == "darkgrey" then colour(64, 64, 64)
	elseif kolor == "lightblue" then colour(173, 216, 230)
	end
end

function fill()
	local x
	local tablica1, tablica2 = {}, {}
	local kolor = {tymczasowy = {screenred(pozycjax, pozycjay), screengreen(pozycjax, pozycjay), screenblue(pozycjax, pozycjay)}}
	dot(pozycjax, pozycjay)
	kolor.nowy = {screenred(pozycjax, pozycjay), screengreen(pozycjax, pozycjay), screenblue(pozycjax, pozycjay)}
	if kolor.nowy[1] == kolor.tymczasowy[1] and kolor.nowy[2] == kolor.tymczasowy[2] and kolor.nowy[3] == kolor.tymczasowy[3]then
		return(nil)
	end
	tablica1 = {pozycjax, pozycjay}
	while (tablica1[1]) do
		for x = 1, #tablica1, 2 do
			if tablica1[x] > 0 and tablica1[x + 1] > 0 and tablica1[x] < screenwidth() - 1 and tablica1[x + 1] < screenheight() - 1  then
				kolor.stary = {screenred(tablica1[x] + 1, tablica1[x + 1]), screengreen(tablica1[x] + 1, tablica1[x + 1]), screenblue(tablica1[x] + 1, tablica1[x + 1])}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica1[x] + 1, tablica1[x + 1])
					table.insert(tablica2, tablica1[x] + 1)
					table.insert(tablica2, tablica1[x + 1])
				end
				kolor.stary = {screenred(tablica1[x] - 1, tablica1[x + 1]), screengreen(tablica1[x] - 1, tablica1[x + 1]), screenblue(tablica1[x] - 1, tablica1[x + 1])}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica1[x] - 1, tablica1[x + 1])
					table.insert(tablica2, tablica1[x] - 1)
					table.insert(tablica2, tablica1[x + 1])
				end
				kolor.stary = {screenred(tablica1[x], tablica1[x + 1] + 1), screengreen(tablica1[x], tablica1[x + 1] + 1), screenblue(tablica1[x], tablica1[x + 1] + 1)}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica1[x], tablica1[x + 1] + 1)
					table.insert(tablica2, tablica1[x])
					table.insert(tablica2, tablica1[x + 1] + 1)
				end
				kolor.stary = {screenred(tablica1[x], tablica1[x + 1] - 1), screengreen(tablica1[x], tablica1[x + 1] - 1), screenblue(tablica1[x], tablica1[x + 1] - 1)}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica1[x], tablica1[x + 1] - 1)
					table.insert(tablica2, tablica1[x])
					table.insert(tablica2, tablica1[x + 1] - 1)
				end
			end
		end
		tablica1={}				
		for x = 1, #tablica2, 2 do
			if tablica2[x] > 0 and tablica2[x + 1] > 0 and tablica2[x] < screenwidth() - 1 and tablica2[x + 1] < screenheight() - 1 then
				kolor.stary = {screenred(tablica2[x] + 1, tablica2[x + 1]), screengreen(tablica2[x] + 1, tablica2[x + 1]), screenblue(tablica2[x] + 1, tablica2[x + 1])}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica2[x] + 1, tablica2[x + 1])
					table.insert(tablica1, tablica2[x] + 1)
					table.insert(tablica1, tablica2[x + 1])
				end
				kolor.stary = {screenred(tablica2[x] - 1, tablica2[x + 1]), screengreen(tablica2[x] - 1, tablica2[x + 1]), screenblue(tablica2[x] - 1, tablica2[x + 1])}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica2[x] - 1, tablica2[x + 1])
					table.insert(tablica1, tablica2[x] - 1)
					table.insert(tablica1, tablica2[x + 1])
				end
				kolor.stary = {screenred(tablica2[x], tablica2[x + 1] + 1), screengreen(tablica2[x], tablica2[x + 1] + 1), screenblue(tablica2[x], tablica2[x + 1] + 1)}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica2[x], tablica2[x + 1] + 1)
					table.insert(tablica1, tablica2[x])
					table.insert(tablica1, tablica2[x + 1] + 1)
				end
				kolor.stary = {screenred(tablica2[x], tablica2[x + 1] - 1), screengreen(tablica2[x], tablica2[x + 1] - 1), screenblue(tablica2[x], tablica2[x + 1] - 1)}
				if kolor.stary[1] == kolor.tymczasowy[1] and kolor.stary[2] == kolor.tymczasowy[2] and kolor.stary[3] == kolor.tymczasowy[3]then
					dot(tablica2[x], tablica2[x + 1] - 1)
					table.insert(tablica1, tablica2[x])
					table.insert(tablica1, tablica2[x + 1] - 1)
				end			
			end
		end		
		tablica2={}
		if redrawstatus == 1 then 
			redraw()
		end
	end
	redraw()
end
